TagLib::Ogg::PageHeader Class Reference

An implementation of the page headers associated with each Ogg::Page. More...

`#include <oggpageheader.h>`

## Public Member Functions

| PageHeader (File *file=nullptr, offset_t pageOffset=-1)
| ~PageHeader ()
| PageHeader (const PageHeader &)=delete
PageHeader & | operator= (const PageHeader &)=delete
bool | isValid () const
List< int > | packetSizes () const
void | setPacketSizes (const List< int > &sizes)
bool | firstPacketContinued () const
void | setFirstPacketContinued (bool continued)
bool | lastPacketCompleted () const
void | setLastPacketCompleted (bool completed)
bool | firstPageOfStream () const
void | setFirstPageOfStream (bool first)
bool | lastPageOfStream () const
void | setLastPageOfStream (bool last)
long long | absoluteGranularPosition () const
void | setAbsoluteGranularPosition (long long agp)
unsigned int | streamSerialNumber () const
void | setStreamSerialNumber (unsigned int n)
int | pageSequenceNumber () const
void | setPageSequenceNumber (int sequenceNumber)
int | size () const
int | dataSize () const
ByteVector | render () const

## Detailed Description

An implementation of the page headers associated with each Ogg::Page.

This class implements Ogg page headers which contain the information about Ogg pages needed to break them into packets which can be passed on to the codecs.

## Constructor & Destructor Documentation

## PageHeader() [1/2]

TagLib::Ogg::PageHeader::PageHeader | ( | File * | file = nullptr,
|  | offset_t | pageOffset = -1 )

Reads a PageHeader from file starting at pageOffset. The defaults create a page with no (and as such, invalid) data that must be set later.

Referenced by operator=(), and PageHeader().

## ~PageHeader()

TagLib::Ogg::PageHeader::~PageHeader | ( |  | ) |

Deletes this instance of the PageHeader.

## PageHeader() [2/2]

TagLib::Ogg::PageHeader::PageHeader | ( | const PageHeader & |  | ) |

delete

References PageHeader().

## Member Function Documentation

## absoluteGranularPosition()

long long TagLib::Ogg::PageHeader::absoluteGranularPosition | ( |  | ) | const

A special value of containing the position of the packet to be interpreted by the codec. In the case of Vorbis this contains the PCM value and is used to calculate the length of the stream.

See also
  setAbsoluteGranularPosition()

## dataSize()

int TagLib::Ogg::PageHeader::dataSize | ( |  | ) | const

Returns the size of the data portion of the page – i.e. the size of the page less the header size.

## firstPacketContinued()

bool TagLib::Ogg::PageHeader::firstPacketContinued | ( |  | ) | const

Some packets can be continued across multiple pages. If the first packet in the current page is a continuation this will return `true`. If this page starts with a new packet this will return `false`.

See also
  lastPacketCompleted()
  setFirstPacketContinued()

## firstPageOfStream()

bool TagLib::Ogg::PageHeader::firstPageOfStream | ( |  | ) | const

This returns `true` if this is the first page of the Ogg (logical) stream.

See also
  setFirstPageOfStream()

## isValid()

bool TagLib::Ogg::PageHeader::isValid | ( |  | ) | const

Returns `true` if the header parsed properly and is valid.

## lastPacketCompleted()

bool TagLib::Ogg::PageHeader::lastPacketCompleted | ( |  | ) | const

Returns `true` if the last packet of this page is completely contained in this page.

See also
  firstPacketContinued()
  setLastPacketCompleted()

## lastPageOfStream()

bool TagLib::Ogg::PageHeader::lastPageOfStream | ( |  | ) | const

This returns `true` if this is the last page of the Ogg (logical) stream.

See also
  setLastPageOfStream()

## operator=()

PageHeader & TagLib::Ogg::PageHeader::operator= | ( | const PageHeader & |  | ) |

delete

References PageHeader().

## packetSizes()

List< int > TagLib::Ogg::PageHeader::packetSizes | ( |  | ) | const

Ogg pages contain a list of packets (which are used by the contained codecs). The sizes of these pages are encoded in the page header. This returns a list of the packet sizes in bytes.

See also
  setPacketSizes()

## pageSequenceNumber()

int TagLib::Ogg::PageHeader::pageSequenceNumber | ( |  | ) | const

Returns the index of the page within the Ogg stream. This helps make it possible to determine if pages have been lost.

See also
  setPageSequenceNumber()

## render()

ByteVector TagLib::Ogg::PageHeader::render | ( |  | ) | const

Render the page header to binary data.

Note
  The checksum – bytes 22 - 25 – will be left empty and must be filled in when rendering the entire page.

References TAGLIB_MSVC_SUPPRESS_WARNING_NEEDS_TO_HAVE_DLL_INTERFACE.

## setAbsoluteGranularPosition()

void TagLib::Ogg::PageHeader::setAbsoluteGranularPosition | ( | long long | agp | ) |

A special value of containing the position of the packet to be interpreted by the codec. It is only supported here so that it may be copied from one page to another.

See also
  absoluteGranularPosition()

## setFirstPacketContinued()

void TagLib::Ogg::PageHeader::setFirstPacketContinued | ( | bool | continued | ) |

Sets the internal flag indicating if the first packet in this page is continued to continued.

See also
  firstPacketContinued()

## setFirstPageOfStream()

void TagLib::Ogg::PageHeader::setFirstPageOfStream | ( | bool | first | ) |

Marks this page as the first page of the Ogg stream.

See also
  firstPageOfStream()

## setLastPacketCompleted()

void TagLib::Ogg::PageHeader::setLastPacketCompleted | ( | bool | completed | ) |

Sets the internal flag indicating if the last packet in this page is complete to completed.

See also
  lastPacketCompleted()

## setLastPageOfStream()

void TagLib::Ogg::PageHeader::setLastPageOfStream | ( | bool | last | ) |

Marks this page as the last page of the Ogg stream.

See also
  lastPageOfStream()

## setPacketSizes()

void TagLib::Ogg::PageHeader::setPacketSizes | ( | const List< int > & | sizes | ) |

Sets the sizes of the packets in this page to sizes. Internally this updates the lacing values in the header.

See also
  packetSizes()

## setPageSequenceNumber()

void TagLib::Ogg::PageHeader::setPageSequenceNumber | ( | int | sequenceNumber | ) |

Sets the page's position in the stream to sequenceNumber.

See also
  pageSequenceNumber()

## setStreamSerialNumber()

void TagLib::Ogg::PageHeader::setStreamSerialNumber | ( | unsigned int | n | ) |

Every Ogg logical stream is given a random serial number which is common to every page in that logical stream. This sets this pages serial number. This method should be used when adding new pages to a logical stream.

See also
  streamSerialNumber()

## size()

int TagLib::Ogg::PageHeader::size | ( |  | ) | const

Returns the complete header size.

## streamSerialNumber()

unsigned int TagLib::Ogg::PageHeader::streamSerialNumber | ( |  | ) | const

Every Ogg logical stream is given a random serial number which is common to every page in that logical stream. This returns the serial number of the stream associated with this packet.

See also
  setStreamSerialNumber()

The documentation for this class was generated from the following file:

- oggpageheader.h